//
//  GameScene.swift
//  BrickBreakerDemo
//
//  Created by Sally McNichols on 10/6/14.
//  Copyright (c) 2014 CMU iOS Development StuCo. All rights reserved.
//

import SpriteKit

class GameScene: SKScene, SKPhysicsContactDelegate{
    var ball: SKSpriteNode
    var paddle: SKSpriteNode
    var isSetup: Bool
    var ballIsMoving: Bool
    var numberOfLives: Int
    var score: Int
    var scoreLabel: SKLabelNode
    var livesLabel: SKLabelNode
    let kScoreHeight: CGFloat = 44.0
    
    func vecMult(a: CGPoint, b: Float) -> CGPoint {
        return CGPointMake(a.x * CGFloat(b), a.y * CGFloat(b))
    }
    
    func vecLength(a: CGPoint) -> Float {
        return sqrtf(Float(a.x * a.x + a.y * a.y))
    }
    
    // Makes a vector have a length of 1
    func vecNormalize(a: CGPoint) -> CGPoint {
        let length: CGFloat = CGFloat(vecLength(a))
        return CGPointMake(a.x / length, a.y / length);
    }
    
    func CGRectGetCenter(rect: CGRect) -> CGPoint {
        return CGPointMake(CGRectGetMidX(rect), CGRectGetMidY(rect));
    }
    
    override init(size: CGSize) {
        // initialize class variables
        self.score = 0
        self.numberOfLives = 3
        self.isSetup = false
        self.ballIsMoving = false
        self.ball = SKSpriteNode(imageNamed: "ball")
        self.paddle = SKSpriteNode(imageNamed:"paddle")
        self.scoreLabel = SKLabelNode(fontNamed: "HelveticaNeue-Light")
        self.livesLabel = SKLabelNode(fontNamed: "HelveticaNeue-Light")
        
        super.init(size: size)
        // TODO
    }
    
    override func didMoveToView(view: SKView) {
        // TODO
    }
    
    func setupScoreDisplay() {
        // TODO
    }
    
    // Setup the blocks for the game
    func setupSceneWithBlocks() {
        // Start in the upper left corner just under the score label
        var startingX: CGFloat = 0.0
        var startingY: CGFloat = kScoreHeight
        var colors: [SKColor] = [SKColor.redColor(),
            SKColor.orangeColor(),
            SKColor.yellowColor(),
            SKColor.greenColor(),
            SKColor.blueColor(),
            SKColor.purpleColor()]
        let blockHeight: CGFloat = 22
        let blockWidth: CGFloat = self.size.width / 12.0
        var col: Int = 0
        
        // Create and add blocks to scene. This will create 4 rows and 12 columns.
        // Outer loop: rows (loop guard might seem weird, but that's because startingY isn't 0
        // Inner loop: columns
        while(startingY < (blockHeight * 6)) {
            while(startingX < self.size.width) {
                // TODO
                
                // increment
                startingX += blockWidth
                col++
            }
            //increment and reset counters for next row
            startingY += blockHeight
            startingX = 0
            col = 0
        }
    }

    override func touchesBegan(touches: Set<UITouch>, withEvent event: UIEvent?) {
        var randomXOffset: CGFloat = (CGFloat(random()) / CGFloat(RAND_MAX)) / 1.5
        if(arc4random() % 2 == 0) {
            randomXOffset *= -1.0
        }
        
        // TODO
    }
    
    override func touchesMoved(touches: Set<UITouch>, withEvent event: UIEvent?) {
        // TODO
    }
    
    func movePaddleToPoint(point: CGPoint) {
        // TODO
    }
    
    override func update(currentTime: CFTimeInterval) {
        // TODO
    }
    
    func didBeginContact(contact: SKPhysicsContact) {
        // TODO
    }
    
    func handleContact(ball: SKSpriteNode, block: SKSpriteNode) {
        // TODO
    }
    
    required init(coder aDecoder: NSCoder) {
        fatalError("init(coder:) has not been implemented")
    }
}
